function chainParticle(type,size,x1,y1,z1,x2,y2,z2,number){
	var x=x2-x1;
	var y=y2-y1;
	var z=z2-z1;
	for(var i=0;i<number;i++){
		Level.addParticle(type,x1+(i/number)*x,y1+(i/number)*y,z1+(i/number)*z,0,0,0,size);
	}
}
var state="wait";
var wire=null;
var count=0;
var Yaw=0;
var plusX=0;
var plusY=0;
var plusZ=0;
var fov=70;
var RAD=180/Math.PI;
function entityAddedHook(entity){
	if(Entity.getEntityTypeId(entity)==77){
		if(state=="wait"){
			var x=Entity.getX(entity);
			var y=Entity.getY(entity);
			var z=Entity.getZ(entity);
			var vx=Entity.getVelX(entity);
			var vy=Entity.getVelY(entity);
			var vz=Entity.getVelZ(entity);
			Entity.remove(entity);
			wire=Level.spawnMob(x+vx*2,y+vy*2,z+vz*2,81);
			Entity.setRenderType(wire,25);
			setVelX(wire,vx*2);
			setVelY(wire,vy*2);
			setVelZ(wire,vz*2);
			state="shot";
		}else{
			state="wait";
			Entity.remove(entity);
			if(Entity.getEntityTypeId(wire)==80)Entity.remove(wire);
			wire=null;
			count=0;
			plusY=0;
			plusX=0;
			plusZ=0;
			ModPE.setGameSpeed(20);
		}
	}
}
function projectileHitBlockHook(projectile,x,y,z,side){
	if(projectile==wire){
		ModPE.setGameSpeed(12);
		plusY=0;
		plusX=0;
		plusZ=0;
		wire=Level.spawnMob(x+0.5,y+0.5,z+0.5,80);
		count=1000;
		state="widing";
		
	}
}
function projectileHitEntityHook(projectile,targetEntity){
	if(projectile==wire){
		ModPE.setGameSpeed(8);
		plusY=Entity.getY(projectile)-Entity.getY(targetEntity);
		plusX=Entity.getX(projectile)-Entity.getX(targetEntity);
		plusZ=Entity.getZ(projectile)-Entity.getZ(targetEntity);
		Yaw=getYaw(targetEntity);
		wire=targetEntity;
		state="widing";
	}
}
function modTick(){
	if(state!="wait"){
		var plus=plus_X_Z();
		chainParticle(ParticleType.crit,1,getPlayerX(),getPlayerY()-1,getPlayerZ(),Entity.getX(wire)+plus.X,Entity.getY(wire)+plusY,Entity.getZ(wire)+plus.Z,25);
		if(Entity.getEntityTypeId(wire)==80){
			count--;
			if(count==0){
				var x=Entity.getX(wire);
				var y=Entity.getY(wire);
				var z=Entity.getZ(wire);
				Entity.remove(wire);
				wire=Level.spawnMob(x,y,z,80);
			}
		}
		if(Entity.getEntityTypeId(wire)<10){
			state="wait";
			wire=null;
			count=0;
			plusY=0;
			plusX=0;
			plusZ=0;
			Yaw=0;
			ModPE.setGameSpeed(20);
		}
	}
	if(state=="widing"){
		if(Entity.getEntityTypeId(wire)==80){
		}else{
			ModPE.setFov(fov);
			if(fov<100)fov+=3;
		}
		Level.addParticle(4,getPlayerX(),getPlayerY()-0.5,getPlayerZ(),0,0,0,100);
		Level.addParticle(4,getPlayerX(),getPlayerY()-0.5,getPlayerZ(),0,0,0,100);
		Level.addParticle(4,getPlayerX(),getPlayerY()-0.5,getPlayerZ(),0,0,0,100);
		Level.addParticle(4,getPlayerX(),getPlayerY()-0.5,getPlayerZ(),0,0,0,100);
		Level.addParticle(4,getPlayerX(),getPlayerY()-0.5,getPlayerZ(),0,0,0,100);
		Level.addParticle(4,getPlayerX(),getPlayerY()-0.5,getPlayerZ(),0,0,0,100);
		Widing(plus);
	}
	if(state=="wait"&&fov>70){
		fov-=6;
		ModPE.setFov(fov);
		if(fov<=70)ModPE.resetFov();
	}
}
function attackHook(attacker,victim){
	if(Entity.getMobSkin(victim)=="mob/giant.png"){
		var size=Entity.getNameTag(victim).split("§大")[1]*2;
		if(getPlayerY()>(Entity.getY(victim)+size*(3/4))){
			Level.playSound(getPlayerX(),getPlayerY(),getPlayerZ(),"mob.zombie.death",100000,0.5);
			Entity.setHealth(victim,0);
		}else{
			preventDefault();
		}
	}
}
function plus_X_Z(){
	var r=Math.sqrt(plusX*plusX+plusZ*plusZ)/2;
	var yaw=(Yaw-getYaw(wire))/RAD+Math.atan2(plusX,plusZ);
	var x=Math.sin(yaw)*r;
	var z=Math.cos(yaw)*r;
	return {X:x,Z:z};
}
function Widing(plus){
	var x=Entity.getX(wire)+plus.X-getPlayerX();
	var y=Entity.getY(wire)+plusY-getPlayerY();
	var z=Entity.getZ(wire)+plus.Z-getPlayerZ();
	var r=Math.sqrt(plusX*plusX+plusZ*plusZ);
	var yaw=Math.atan2(z,x);
	var pitch=Math.atan2(y,r);
	setVelX(getPlayerEnt(),Entity.getVelX(getPlayerEnt())+Math.cos(yaw)/2);
	setVelY(getPlayerEnt(),Entity.getVelY(getPlayerEnt())+Math.sin(pitch)/2);
	setVelZ(getPlayerEnt(),Entity.getVelZ(getPlayerEnt())+Math.sin(yaw)/2);
}
function leaveGame(){
	state="wait";
	wire=null;
	count=0;
	Yaw=0;
	plusX=0;
	plusY=0;
	plusZ=0;
	fov=70;
}